@echo off
setlocal EnableDelayedExpansion

rem F_USE_PNPUTIL=0 to use devcon and F_USE_PNPUTIL=1 to use pnputil
set F_USE_PNPUTIL=0

rem set mtk_string="Netgear A8000 WiFi 6/6E adapter"

set driver_installed=0
set DRIVER_INF_TO_INSTALL=mtkwl6eu

rem initialize colour function for prints
call :initColorPrint

rem CheckOS
if "%PROCESSOR_ARCHITECTURE%"=="x86" (
	set ARCH_FOLDER=x86
	set INF_ARCH_SUFFIX=
) else (
	set ARCH_FOLDER=x64
	set INF_ARCH_SUFFIX=x
)

rem get installtion or unstallation parameter from user
rem set /p Install_Uninstall="Enter [i to install] [u to uninstall] driver:"
set Install_Uninstall=%1
IF "%Install_Uninstall%"=="i" (
	goto :CHECK_UNINSTALL
) ELSE IF "%Install_Uninstall%"=="u" (
	 GOTO :CHECK_UNINSTALL
) ELSE (
   @echo "You Entered wrong options,Try again"
   echo .
   echo . Enter %: i = Install driver
   echo .         u = Uninstall driver
   echo . Usages %:
   echo .          MtkInstaller.bat i
   echo .        or
   echo .          MtkInstaller.bat u
   echo .
   GOTO DONE
)

rem function to parse vid pid entry in vidpid.ini file
:PARSE_DEVICE_ENTRY
	rem echo ["%~1"]
	set VID_PID_UNINSTALL=""

rem 	for /F "tokens=1 delims=; " %%a in ("%~1") do (
rem 		set "DEVICE_TYPE=%%a"
rem 	)
rem 	for /F "tokens=2 delims=; " %%b in ("%~1") do (
rem 		set "DRIVER_INF_TO_INSTALL=%%b"
rem 	)
	for /F "tokens=2 delims== " %%b in ("%~1") do (
		set VID_PID_UNINSTALL="%%b"
	)
	
	rem for /F "tokens=4 delims=; " %%b in ("%~1") do (
	rem 	set "INF_PATH=%%b"
	rem )

	
	echo DRIVER_INF_TO_INSTALL    :     "%DRIVER_INF_TO_INSTALL%"
	echo VID_PID_UNINSTALL        :     %VID_PID_UNINSTALL%

	if %VID_PID_UNINSTALL%=="USB\VID_0E8D&PID_7961" (
		echo "Installing driver for MediaTek Wi-Fi 6/6E Wireless USB LAN Card"
		set mtk_string="MediaTek Wi-Fi 6/6E Wireless USB LAN Card"
		rem set mtk_string="Netgear A8000 WiFi 6/6E adapter"

	) else if %VID_PID_UNINSTALL%=="USB\VID_0846&PID_9060" (
		rem set mtk_string="Netgear A8000 WiFi 6&6E Adapter"
		set mtk_string="Netgear A8000 WiFi 6"
		echo "Installing driver for Netgear A8000 WiFi 6&6E Adapter"
	
	) else if %VID_PID_UNINSTALL%=="USB\VID_3574&PID_6211" (
		set mtk_string="COMFAST WiFi6/6E USB Wireless adapter"
		echo "Installing driver for COMFAST WiFi6/6E USB Wireless adapter"
		
	) else (
		set mtk_string="MediaTek Wi-Fi 6/6E Wireless USB LAN Card"
		echo "Installing Driver for common Adapter.." 
	
	)

exit /B 0

rem function to get oem inf file name from "pnputil /e" command
:GET_OEM_INF
	rem get the line which contains "oem" and "Class"
	echo calling GET_OEM_INF to get the OEM Number.
	set numbers=
	set DeviceClass=

	rem Store the "oem" inf file in an array
	set OEM_INF[]=
	set INF_NUM[]=
	set "idx=0"
	set inf_file_1=


	rem List all the oem inf files which are installed and result is saved in 1.txt file
	 pnputil -e > 2.txt
	
	rem get the line number which has "Mediatek" string and
	rem store before/after line numbers which include mediatek string.
	for /F "delims=:" %%a in ('findstr /I /N /C:"Mediatek" 2.txt') do (  
		set /A before=%%a-1
		set "numbers=!numbers!!before!: "  
		set /A after=%%a+1
		set "DeviceClass=!DeviceClass!!after!: " 
	   	echo numbers: !numbers!	
	)
	
	if "%numbers%" NEQ "" (
		for /F "tokens=1* delims=:" %%a in ('findstr /N "^" 2.txt ^| findstr /B "%numbers%" ^| findstr /I /N /C:"oem"') do (
			set "OEM_INF[%idx%]=%%b"
			echo debug 4 OEM_INF !OEM_INF[%idx%]!
			set "inf_name=!OEM_INF[%idx%]!"
			echo debug 5 !inf_name!
			set "inf_file_1=!inf_name: =!" 
			echo debug 6 !inf_file_1!
			rem set "inf_file_1=!inf_file_1:Publishedname:=!"
			set inf_file_1=!inf_file_1:*:=!
			echo debug 7 !inf_file_1!
			set inf_file_1=!inf_file_1:*:=!
			echo debug 8 !inf_file_1!
			set "INF_NUM[!idx!]=!inf_file_1!"
			set /a "idx+=1"
		)
	)  
	
exit /B 0

rem function to get HW id from "devcon /hwids *" command
:GET_HW_ID
	rem Lists down the list of hwids of the enumerated devices and output is copied into 1.txt file
	
	set "hwids="
	if "%PROCESSOR_ARCHITECTURE%"=="x86" (
		.\devcon.exe hwids * > 1.txt
	) else (
		.\devcon_x64.exe hwids * > 1.txt
	)
	echo search for vidpid = %VID_PID_UNINSTALL%
	for /F "delims=:" %%a in ('FINDSTR /I /N %VID_PID_UNINSTALL% 1.txt') do (   
		set "hwids=%%a"
		echo hwid process %%a
	)
	
	rem Prints the string present the given line number and stored into variable Hwid
	for /F "tokens=1* delims=: " %%a in ('findstr /N "^" 1.txt ^| findstr /B "%hwids%"') do (
		set "Hwid=%%b"
		goto :HW_ID_FOUND
	)
	:HW_ID_FOUND
	echo HwId = ["%Hwid%"]
exit /B 0

rem :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
rem ::::::::::::::::::::::::::::::::::::::::::::::::::UNINSTALL::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
rem :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:CHECK_UNINSTALL
	for /F "tokens=1*" %%a in (VIDPID.ini) do ( 
		call :colorPrint 1 " ###############################################################" /n
		call :colorPrint 1 " Iterate on device : %%a" /n
		call :PARSE_DEVICE_ENTRY "%%a"
		call :UNINSTALL
	)
	timeout 3
	if %Install_Uninstall%==i	goto :CHECK_INSTALL
goto DONE

rem function to uninstall a device
:UNINSTALL
	echo .
	echo .
	call :colorPrint c " ***************************************************************" /n
	rem echo  "Uninstalling Hardware ID = "%VID_PID_UNINSTALL%"" 
	
	set Hwid_Remove=""
	set Hwid_Remove=%VID_PID_UNINSTALL:~0,-1%
	echo Hwid_Remove - %Hwid_Remove%


	rem Checks for the line number which contains the string 'Mediatek' in 1.txt file

	call :DELETE_REGISTRY
exit /B 0

:DELETE_REGISTRY
	echo Deleting the registy during the un-install %hwid% %VID_PID_UNINSTALL%
	REG QUERY "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\NetworkCards" /s /f %mtk_string% > 1.txt
	echo REG QUERY "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\NetworkCards" /s /f %mtk_string%

	findstr /c:"0 match" 1.txt > nul


	IF NOT ERRORLEVEL 1 (
		rem No registry with installed hardware. Nothing to do.
		echo NO registry found with specified hardware %mtk_string%.
	) ELSE (
		echo Registry found with specified hardware %mtk_string%.

		for /F "delims=" %%a in ('findstr HKEY_LOCAL_MACHINE 1.txt') do (	
			echo Deleting Registry entry :%%a
			REG DELETE "%%a" /f
			echo REG DELETE "%%a" /f
		)
	)

	
	REG QUERY HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Class\{4d36e972-e325-11ce-bfc1-08002be10318} /s /f %mtk_string% > 1.txt
	
	echo REG QUERY HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Class\{4d36e972-e325-11ce-bfc1-08002be10318} /s /f %mtk_string% 

	findstr /c:"0 match" 1.txt > nul

	IF NOT ERRORLEVEL 1 (
		rem No registry with installed hardware. Nothing to do.
		echo NO registry found with specified hardware %mtk_string%.
	) ELSE (
		echo Registry found with specified hardware %mtk_string%.

		for /F "delims=" %%a in ('findstr HKEY_LOCAL_MACHINE 1.txt') do (

			set mtk_oem=""
			REG QUERY %%a | findstr InfPath > InfString.txt
			echo REG QUERY %%a | findstr InfPath
			
			for /F "tokens=3 delims= " %%b in (InfString.txt) do (
				echo Deleting the OEM file number: %%b
				set "mtk_oem=%%b"
			)
			

			if "%PROCESSOR_ARCHITECTURE%"=="x86" (
				.\devcon.exe /r remove %Hwid_Remove%*%
				echo .\devcon.exe /r remove %Hwid_Remove%*%
		 		echo pnputil /force /delete-driver !mtk_oem! /uninstall
				pnputil /force /delete-driver !mtk_oem! /uninstall 

				.\devcon.exe rescan

			) else (
				.\devcon_x64.exe /r remove %Hwid_Remove%*"
				echo .\devcon_x64.exe /r remove %Hwid_Remove%*"
		 		echo pnputil /force /delete-driver !mtk_oem! /uninstall 
		 		pnputil /force /delete-driver !mtk_oem! /uninstall 

				.\devcon_x64.exe rescan	
			)

			rem echo Deleting Registry entry :%%a
			
			echo REG DELETE "%%a" /f
			REG DELETE "%%a" /f

			echo REG DELETE "%%a" /f
	        )
      )

exit /B 0


rem :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
rem ::::::::::::::::::::::::::::::::::::::::::::::::::INSTALL::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
rem :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::    

:CHECK_INSTALL
	for /F "tokens=1*" %%a in (VIDPID.ini) do ( 
		call :colorPrint 1 " ###############################################################" /n
		call :colorPrint 1 " Iterate on device" /n
		call :PARSE_DEVICE_ENTRY "%%a"
		call :INSTALL
	)
goto DONE

rem function to install a device with inf name and hwid
:INSTALL
	echo .
	echo .
	call :colorPrint a " ===============================================================" /n
	call :colorPrint a " Installing Hardware ID = "%VID_PID_UNINSTALL%"" /n
	
	if "%driver_installed%" == "1" (
		echo Driver is already installed. No need to install the same driver again with another HWid..
		if "%PROCESSOR_ARCHITECTURE%"=="x86" (
			.\devcon.exe rescan
			.\devcon.exe restart %VID_PID_UNINSTALL%
			echo .\devcon.exe restart %VID_PID_UNINSTALL%
		) else (
			.\devcon_x64.exe rescan
			.\devcon_x64.exe restart %VID_PID_UNINSTALL%
			rem .\devcon_x64.exe restart "USB\VID_0E8D&PID_7961*"
			echo .\devcon_x64.exe restart %VID_PID_UNINSTALL%
		)
	
		exit /b
	)	
	rem get oem inf name
	IF [%inf_file%] == [inf] (
		 @echo "No INF files present in Store,Previously installed driver is cleanly removed"
	)

	if "%PROCESSOR_ARCHITECTURE%"=="x86" (
		.\devcon.exe rescan
	) else (
		.\devcon_x64.exe rescan
	)

	call :GET_HW_ID
	echo hw id from system for installation is = "%Hwid%"

		
	IF ["%Hwid%"]==[""] (
 		 echo "Device is not enumerated,but installing the driver."

		 echo inf with path = ".\%DRIVER_INF_TO_INSTALL%%INF_ARCH_SUFFIX%.inf"
		 
		 echo pnputil -a .\%DRIVER_INF_TO_INSTALL%%INF_ARCH_SUFFIX%.inf
		 pnputil -a .\%DRIVER_INF_TO_INSTALL%%INF_ARCH_SUFFIX%.inf
		 exit /b 
 	)

	set "Hwid=%Hwid: =%"
	set "Hwid=%Hwid:~0,21%"	
	echo hw id processed for installation is = "%Hwid%"
	rem Install the driver even if it's not inserted.

	rem Device is enumerated,Just update the driver for the device
	echo installing driver for hwid = "%Hwid%" and inf "%DRIVER_INF_TO_INSTALL%%INF_ARCH_SUFFIX%.inf"
	
	echo inf with path = ".\%DRIVER_INF_TO_INSTALL%%INF_ARCH_SUFFIX%.inf"
	
	rem .\devcon_x64.exe update .\%DRIVER_INF_TO_INSTALL%%INF_ARCH_SUFFIX%.inf "%Hwid%"
	rem Force installation is getting leads to code10.
	rem pnputil -f -a .\%DRIVER_INF_TO_INSTALL%%INF_ARCH_SUFFIX%.inf /install
	echo pnputil -a .\%DRIVER_INF_TO_INSTALL%%INF_ARCH_SUFFIX%.inf  
	pnputil -a .\%DRIVER_INF_TO_INSTALL%%INF_ARCH_SUFFIX%.inf 

	timeout 2

	if "%PROCESSOR_ARCHITECTURE%"=="x86" (
		 .\devcon.exe restart "%Hwid%"	
		echo .\devcon.exe restart "%Hwid%"	
		.\devcon.exe rescan
	) else (
		.\devcon_x64.exe restart "%Hwid%"	
		echo .\devcon_x64.exe restart "%Hwid%"	
		.\devcon_x64.exe rescan
	)	
	set /a driver_installed=1

	timeout 3
exit /B 0


rem COLOR STUFF START--->>>>
goto EOF
:colorPrint Color  Str  [/n]
setlocal
set "str=%~2"
call :colorPrintVar %1 str %3
endlocal
exit /b 

:colorPrintVar  Color  StrVar  [/n]
if not defined %~2 exit /b 0
setlocal enableDelayedExpansion
set "str=a%DEL%!%~2:\=a%DEL%\..\%DEL%%DEL%%DEL%!"
set "str=!str:/=a%DEL%/..\%DEL%%DEL%%DEL%!"
set "str=!str:"=\"!"
pushd "%temp%"
findstr /p /A:%1 "." "!str!\..\x" nul
if /i "%~3"=="/n" echo(
endlocal
exit /b 

:initColorPrint
for /F "tokens=1,2 delims=#" %%a in ('"prompt #$H#$E# & echo on & for %%b in (1) do rem"') do set "DEL=%%a"
<nul >"%temp%\x" set /p "=%DEL%%DEL%%DEL%%DEL%%DEL%%DEL%.%DEL%"
exit /b 

rem COLOR STUFF ENDS<<<...........................


rem :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
rem :::::::::::::::::::::::::::::::::::::::::::::::::DONE::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
rem :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:DONE
if exist 1.txt del 1.txt
if exist 2.txt del 2.txt
if exist InfString.txt del InfString.txt

@echo "DONE!"
endlocal
